<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: main.inc.php,v 1.14.6.1 2020/10/16 07:45:43 dgoron Exp $


if (stristr ( $_SERVER ['REQUEST_URI'], ".inc.php" ))
	die ( "no access" );

global $class_path, $include_path, $sub, $action, $msg;
global $database_window_title, $admin_layout, $form_actif, $adminTransOpac, $date_purge, $lang, $id, $statutDef, $sens, $idLoc;

require_once ($class_path . "/transferts.class.php");
require_once ($class_path . "/transfert.class.php");

transferts::set_sub($sub);
transferts::init_params();

// action en fonction du type
switch ( $sub) {
	case 'general' :
	case 'circ' :
	case 'opac' :
		//l'entete de la page
		$admin_layout = str_replace ( '!!menu_sous_rub!!', $msg ["admin_tranferts_" . $sub], $admin_layout );
		print $admin_layout . "<br />";
		
		switch ( $action) {
			case "modif" :
				//on est en modification
				print transferts::get_display_parameters();
				break;
			case "enregistre" :
				//on enregistre les modifications
				if ($form_actif) {
					if ($sub == 'opac') { //Cas particulier quand on bascule d'une valeur  une autre du slecteur
						transferts::check_loc_retrait_resas($adminTransOpac);
					}
					transferts::save_parameters();
				}
				//puis on affiche le tableau
				print transferts::get_display_parameters();
				break;
			default :
				//on affiche le tableau
				print transferts::get_display_parameters();
				break;
		}
		break;
	case 'ordreloc' :
		//gere l'ordre des localisations pour la recherche d'un exemplaire
		$admin_layout = str_replace ( '!!menu_sous_rub!!', $msg ["admin_tranferts_ordre_localisation"], $admin_layout );
		print $admin_layout . "<br />";
		switch ( $action) {
			case "enregistre" :
				//on enregistre les modifications
				transferts::save_location_order( $sens, $idLoc );
				//puis on affiche le tableau
				print transferts::get_display_location_order();
				break;
			default :
				//on affiche le tableau
				print transferts::get_display_location_order();
				break;
		}
		break;
	case 'statutsdef' :
		//gere le statut par dfaut de l'exemplaire lors de la rception
		$admin_layout = str_replace ( '!!menu_sous_rub!!', $msg ["admin_tranferts_statuts_defaut"], $admin_layout );
		print $admin_layout . "<br />";
		switch ($action) {
			case "modif" :
				//on est en modification
				print transferts::get_display_default_status($id);
				break;
			case "enregistre" :
				//on enregistre les modifications
				transferts::save_default_status($id, $statutDef);
				//puis on affiche le tableau
				print transferts::get_display_list_default_statuses();
				break;
			default :
				//on affiche le tableau
				print transferts::get_display_list_default_statuses();
				break;
		}
		break;
	case 'purge' :
		//gere le statut par dfaut de l'exemplaire lors de la rception
		$admin_layout = str_replace ( '!!menu_sous_rub!!', $msg ["admin_tranferts_purge"], $admin_layout );
		print $admin_layout . "<br />";
		
		switch ( $action) {
			case "purge" :
				//on enregistre les modifications
				transferts::admin_purge_historique ( $date_purge );
				//le message de purge effectue
				echo str_replace ( "!!date_purge!!", formatdate ( $date_purge ), $msg ["admin_transferts_message_purge"] );
				//puis on affiche l'ecran
				print transferts::get_display_purge();
				break;
			default :
				//on affiche l'ecran de purge
				print transferts::get_display_purge();
				break;
		}
		break;
	default :
		//affiche l'cran d'information par dfaut
		$admin_layout = str_replace ( '!!menu_sous_rub!!', "", $admin_layout );
		print $admin_layout . "<br />";
		echo window_title ( $database_window_title . $msg [7] . $msg [1003] . $msg [1001] );
		
		//on affiche le message de prsentation
		include ("$include_path/messages/help/$lang/admin_transferts.txt");
		break;
}

?>
