<?php
// +-------------------------------------------------+
// | 2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: list_resa_planning_circ_reader_ui.class.php,v 1.1.2.5 2020/10/22 10:38:30 dgoron Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/list/resa_planning/list_resa_planning_circ_ui.class.php");

class list_resa_planning_circ_reader_ui extends list_resa_planning_circ_ui {
	
    protected function init_default_selected_filters() {
        $this->selected_filters = array();
    }
    
	protected function init_default_columns() {
	    global $pmb_location_resa_planning;
		
		$this->add_column('record');
		$this->add_column('resa_date');
		$this->add_column('resa_date_debut');
		$this->add_column('resa_date_fin');
		$this->add_column('resa_qty');
		$this->add_column('resa_validee');
		$this->add_column('resa_confirmee');
		if ($pmb_location_resa_planning=='1') {
		    $this->add_column('resa_loc_retrait');
		}
		$this->add_column('resa_delete', 'resa_suppr_th');
	}
	
	protected function init_default_applied_sort() {
	    $this->add_applied_sort('record');
	    $this->add_applied_sort('resa_date');
	}
	
	protected function get_cell_content($object, $property) {
	    $content = '';
	    switch($property) {
	        case 'resa_delete':
                $content .= "<input type='button' id='resa_supp' name='resa_supp' class='bouton' value='X' onclick=\"document.location='./circ.php?categ=pret&sub=suppr_resa_planning_from_fiche&action=suppr_resa&id_resa=".$object->id_resa."&id_empr=".$object->resa_idempr."';\" />" ;
	            break;
	        default :
	            $content .= parent::get_cell_content($object, $property);
	            break;
	    }
	    return $content;
	}
	
	/**
	 * Affiche la liste
	 */
	public function get_display_list() {
	    
	    //Rcupration du script JS de tris
	    $display = $this->get_js_sort_script_sort();
	    
	    $display .= $this->get_js_func_callback();
	    
	    //Affichage de la liste des objets
	    $display .= $this->get_display_objects_list();
	    $display .= $this->pager();
	    return $display;
	}
	
	public function get_export_icons() {
	   return "";    
	}
	
	public static function get_controller_url_base() {
		global $base_path;
	
		return $base_path.'/circ.php?categ=pret';
	}
}