<?php
// +-------------------------------------------------+
// | 2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: list_reservations_edition_treat_ui.class.php,v 1.1.2.5 2020/10/22 10:38:29 dgoron Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

global $class_path;
require_once($class_path."/list/reservations/list_reservations_edition_ui.class.php");

class list_reservations_edition_treat_ui extends list_reservations_edition_ui {
	
	protected function add_object($row) {
		global $pmb_transferts_actif;
		
		$resa = new reservation($row->resa_idempr, $row->resa_idnotice, $row->resa_idbulletin);
		
		// on compte le nombre total d'exemplaires prtables pour la notice
		$total_ex = $resa->get_number_expl_lendable();
		
		// on compte le nombre d'exemplaires sortis
		$total_sortis = $resa->get_number_expl_out();
		
		// on en dduit le nombre d'exemplaires disponibles
		$total_dispo = $total_ex - $total_sortis ;
		
		// on a au moins UN dispo :
		if ($total_dispo > 0) {
			$available = true;
			$rank = recupere_rang($row->resa_idempr, $row->resa_idnotice, $row->resa_idbulletin) ;
			if($rank>$total_dispo)	$available = false;
			
			if ($pmb_transferts_actif == "1") {
				$dest_loc = resa_loc_retrait($resa->id);
				
				if ($dest_loc!=0) {
					$total_ex = $resa->get_number_expl_lendable($dest_loc);
					if ($total_ex==0) {
						//on a pas d'exemplaires sur le site de retrait
						//on regarde si on en ailleurs
						$total_ex = $resa->get_number_expl_lendable($dest_loc, true);
						if ($total_ex!=0) {
							//on en a au moins un ailleurs!
							//on regarde si un des exemplaires n'est pas en transfert pour cette resa !
							$query = "SELECT id_transfert FROM transferts WHERE etat_transfert=0 AND origine=4 AND origine_comp=".$resa->id." limit 1";
							$tresult = pmb_mysql_query($query);
							if (pmb_mysql_num_rows($tresult)) {
								//on a un transfert en cours
								$available = false;
							} elseif($total_ex>=$rank)	{
								if(!$resa->transfert_resa_dispo($dest_loc)){
									//non disponible dans une autre localisation
									$available = false;
								}
							}
						}
					}
				}
			}
			// un exemplaire est disponible pour cette resa
			if ($available) {
				$tableau_expl_dispo = expl_dispo ($row->resa_idnotice, $row->resa_idbulletin) ;
				if (count($tableau_expl_dispo)) {
					for ($i=0;$i<count($tableau_expl_dispo);$i++) {
						if (!$this->filters['available_location'] || ($tableau_expl_dispo[$i]['idlocation'] == $this->filters['available_location'])) {
							$resa->expl_cb = $tableau_expl_dispo[$i]['expl_cb'];
							$resa->expl_id = $tableau_expl_dispo[$i]['expl_id'];
							$exemplaire = new exemplaire($tableau_expl_dispo[$i]['expl_cb'], $tableau_expl_dispo[$i]['expl_id']);
							$resa->set_exemplaire($exemplaire);
							$this->objects[] = $resa;
							$this->location_reservations[$row->id_resa] = $row->idlocation;
						}
					}
				}
			} else {
				$this->pager['nb_results']--;
			}
		}
	}
	
	protected function fetch_data() {
		parent::fetch_data();
		$this->pager['nb_results'] = count($this->objects);
	}
	
	protected function get_title() {
		global $msg;
		return "<h1>".$msg[350]."&nbsp;&gt;&nbsp;".$msg['edit_resa_menu_a_traiter']."</h1>";
	}
	
	protected function get_form_title() {
		global $msg;
		
		return $msg['edit_resa_menu_a_traiter'];
	}
	
	protected function init_default_selected_filters() {
		global $pmb_transferts_actif, $pmb_location_reservation;
		
		if ($pmb_transferts_actif=="1" || $pmb_location_reservation) {
			$this->add_selected_filter('resa_loc_retrait');
			$this->add_selected_filter('available_location');
		} else {
			parent::init_default_selected_filters();
		}
	}
	
	protected function init_default_columns() {
		global $pmb_transferts_actif;
		
		$this->add_column('rank');
		$this->add_column('empr');
		$this->add_column('empr_location', 'edit_resa_empr_location');
		$this->add_column('record');
		$this->add_column('expl_location');
		$this->add_column('section');
		$this->add_column('expl_cote');
		$this->add_column('statut');
		$this->add_column('support');
		$this->add_column('expl_cb');
		if ($pmb_transferts_actif=="1") {
			$this->add_column('resa_loc_retrait');
		}
	}
	
	protected function init_default_pager() {
		parent::init_default_pager();
		$this->pager['nb_per_page'] = pmb_mysql_result(pmb_mysql_query("SELECT count(*) FROM resa"), 0, 0); //Illimit;
		$this->set_pager_in_session();
	}
	
	
	protected function get_display_spreadsheet_title() {
		global $msg;
		$this->spreadsheet->write_string(0,0,$msg[350].": ".$msg['edit_resa_menu_a_traiter']);
	}
	
	protected function get_html_title() {
		global $msg;
		return "<h1>".$msg[350]."&nbsp;&gt;&nbsp;".$msg['edit_resa_menu_a_traiter']."</h1>";
	}
}