<?php
// +-------------------------------------------------+
// | 2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: list_reservations_ui.class.php,v 1.1.6.12 2020/08/18 12:06:23 dgoron Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/list/list_ui.class.php");
require_once($class_path."/emprunteur.class.php");
require_once($class_path."/resa.class.php");
require_once($class_path."/resa_situation.class.php");
require_once($class_path."/notice.class.php");
require_once($class_path."/expl.class.php");

class list_reservations_ui extends list_ui {
	
	protected $location_reservations;
	
	protected $precedenteresa_idnotice;
	
	protected $precedenteresa_idbulletin;
	
	protected $no_aff;
	
	protected $resa_situation;
	
	protected $lien_deja_affiche;
	
	protected static $ancre;
	
	protected function _get_query_base() {
		$query = "SELECT id_resa, resa_idempr, resa_idnotice, resa_idbulletin, resa_cb, resa_confirmee, idlocation,
			ifnull(expl_cote,'') as expl_cote, expl_cb,
			trim(concat(if(series_m.serie_name <>'', if(notices_m.tnvol <>'', concat(series_m.serie_name,', ',notices_m.tnvol,'. '), concat(series_m.serie_name,'. ')), if(notices_m.tnvol <>'', concat(notices_m.tnvol,'. '),'')),
			if(series_s.serie_name <>'', if(notices_s.tnvol <>'', concat(series_s.serie_name,', ',notices_s.tnvol,'. '), series_s.serie_name), if(notices_s.tnvol <>'', concat(notices_s.tnvol,'. '),'')),
			ifnull(notices_m.tit1,''),ifnull(notices_s.tit1,''),' ',ifnull(bulletin_numero,''), if (mention_date, concat(' (',mention_date,')') ,''))) as tit
			FROM ((((resa LEFT JOIN notices AS notices_m ON resa_idnotice = notices_m.notice_id LEFT JOIN series AS series_m ON notices_m.tparent_id = series_m.serie_id )
			LEFT JOIN bulletins ON resa_idbulletin = bulletins.bulletin_id)
			LEFT JOIN notices AS notices_s ON bulletin_notice = notices_s.notice_id
			LEFT JOIN series AS series_s ON notices_s.tparent_id = series_s.serie_id)
			LEFT JOIN exemplaires ON resa_cb = exemplaires.expl_cb), docs_location, empr ";
		return $query;
	}
	
	protected function add_object($row) {
		$no_aff=0;
		if(!($this->filters['id_notice'] || $this->filters['id_bulletin']))
			if($this->filters['f_loc'] && !$this->filters['id_empr'] && $row->resa_cb && $row->resa_confirmee){
				// Dans la liste des rsa  traiter, on n'affiche pas la rsa qui a t affect par un autre site
				$query = "SELECT expl_location FROM exemplaires WHERE expl_cb='".$row->resa_cb."' ";
				$res = @pmb_mysql_query($query);
				if(($data_expl = pmb_mysql_fetch_array($res))){
					if($data_expl['expl_location']!=$this->filters['f_loc']) {
						$no_aff=1;
					}
				}
		}
		if(!$no_aff || ($this->filters['id_notice'] || $this->filters['id_bulletin'])) {
			if($this->filters['id_empr']) {
				$this->filters['f_loc']=0;
				$this->filters['removal_location']=0;
			}
			$resa = new reservation($row->resa_idempr, $row->resa_idnotice, $row->resa_idbulletin, $row->resa_cb);
			$resa->get_resa_cb();
			$this->objects[] = $resa;
			$this->location_reservations[$row->id_resa] = $row->idlocation;
		}
	}
		
	/**
	 * Tri SQL
	 */
	protected function _get_query_order() {
		
		if($this->applied_sort[0]['by']) {
			$order = '';
			$sort_by = $this->applied_sort[0]['by'];
			switch($sort_by) {
				case 'record':
					$order .= 'tit';
					break;
				case 'expl_cote' :
				case 'resa_date' :
				case 'resa_date_debut' :
				case 'resa_date_fin' :
				case 'expl_cb' :
					$order .= $sort_by;
					break;
				default :
					$order .= parent::_get_query_order();
					break;
			}
			if($order) {
				$this->applied_sort_type = 'SQL';
				return " group by resa_idnotice, resa_idbulletin, resa_idempr order by ".$order." ".$this->applied_sort[0]['asc_desc'];
			} else {
				return " group by resa_idnotice, resa_idbulletin, resa_idempr";
			}
		}
	}
	
	/**
	 * Initialisation des filtres disponibles
	 */
	protected function init_available_filters() {
		global $pmb_transferts_actif, $pmb_location_reservation;
		
		$this->available_filters =
		array('main_fields' =>
				array(
						'montrerquoi' => 'empr_etat_resa_query',
						'removal_location' => 'transferts_circ_resa_lib_localisation',
				)
		);
		if ($pmb_transferts_actif=="1" || $pmb_location_reservation) {
			$this->available_filters['main_fields']['available_location'] = 'edit_resa_expl_available_filter';
			$this->available_filters['main_fields']['resa_loc_retrait'] = 'edit_resa_expl_location_filter';
		}
		$this->available_filters['custom_fields'] = array();
	}
	
	/**
	 * Initialisation des filtres de recherche
	 */
	public function init_filters($filters=array()) {
		global $pmb_lecteurs_localises, $deflt_resas_location;
		global $pmb_transferts_actif, $transferts_choix_lieu_opac, $pmb_location_reservation;
		global $f_loc;
		
		$this->filters = array(
    		    'id_notice' => 0,
    		    'id_bulletin' => 0,
    		    'id_empr' => 0,
    		    'montrerquoi' => 'all',
				'f_loc' => ($f_loc == '' ? $deflt_resas_location : $f_loc),
				'removal_location' => '',
				'available_location' => '',
				'resa_state' => '',
		);
		$this->filters['resa_loc'] = 0;
		if ($pmb_transferts_actif=="1" && $this->filters['f_loc'] && empty($filters['id_empr'])) {
			switch ($transferts_choix_lieu_opac) {
				case "1":
					//retrait de la resa sur lieu choisi par le lecteur
					$this->filters['resa_loc_retrait'] = $this->filters['f_loc'];
					break;
				case "2":
					//retrait de la resa sur lieu fix
					break;
				case "3":
					//retrait de la resa sur lieu exemplaire
					// On affiche les rsa que peut satisfaire la loc
					// respecter les droits de rservation du lecteur
					if($pmb_location_reservation) {
						$this->filters['resa_loc'] = $this->filters['f_loc'];
					}
					break;
				default:
					//retrait de la resa sur lieu lecteur
					break;
			}
		}elseif($pmb_location_reservation && $this->filters['f_loc'] && empty($filters['id_empr'])) {
			$this->filters['resa_loc'] = $this->filters['f_loc'];
		}
		if($this->filters['id_notice'] || $this->filters['id_bulletin']) {
			$this->filters['f_loc'] = 0;
			$this->filters['removal_location'] = 0;
		}
		parent::init_filters($filters);
	}
	
	protected function init_no_sortable_columns() {
	    $this->no_sortable_columns = array(
	        'resa_delete'
	    );
	}
	
	/**
	 * Initialisation des colonnes disponibles
	 */
	protected function init_available_columns() {
		global $pmb_transferts_actif;
		
		$this->available_columns =
		array('main_fields' =>
				array(
						'record' => '233',
						'expl_cote' => '296',
						'empr' => 'empr_nom_prenom',
						'empr_location' => 'empr_location',
						'rank' => '366',
						'resa_date' => '374',
						'resa_condition' => 'resa_condition',
						'resa_date_debut' => 'resa_date_debut_td',
						'resa_date_fin' => 'resa_date_fin_td',
						'resa_validee' => 'resa_validee',
						'resa_confirmee' => 'resa_confirmee',
						'expl_location' => 'edit_resa_expl_location',
						'section' => '295',
						'statut' => '297',
						'support' => '294',
						'expl_cb' => '232'
				)
		);
		if ($pmb_transferts_actif=='1') {
			$this->available_columns['main_fields']['resa_loc_retrait'] = 'resa_loc_retrait';
		}
	}
	
	/**
	 * Initialisation des settings par dfaut
	 */
	protected function init_default_settings() {
		parent::init_default_settings();
		$this->set_setting_column('expl_cb', 'text', array('bold' => true));
		$this->set_setting_column('record', 'align', 'left');
		$this->set_setting_column('record', 'text', array('bold' => true));
		$this->set_setting_column('resa_validee', 'text', array('strong' => true));
		$this->set_setting_column('resa_confirmee', 'text', array('strong' => true));
	}
	
	/**
	 * Initialisation de la pagination par dfaut
	 */
	protected function init_default_pager() {
		parent::init_default_pager();
		$this->pager['nb_per_page'] = 40;
	}
	
	/**
	 * Filtres provenant du formulaire
	 */
	public function set_filters_from_form() {
		$this->set_filter_from_form('montrerquoi');
		$this->set_filter_from_form('removal_location');
		$this->set_filter_from_form('available_location');
		$this->set_filter_from_form('resa_loc_retrait');
		parent::set_filters_from_form();
	}
	
	protected function get_search_filter_montrerquoi() {
		global $msg, $charset;
		
		//Selecteur rservations validees/confirmees
		$search_filter = "
            <span class='list_ui_montrerquoi_checkbox ".$this->objects_type."_montrerquoi_checkbox'>
                <input type='radio' name='".$this->objects_type."_montrerquoi' value='all' id='all' ".($this->filters['montrerquoi'] == 'all' ? "checked='checked'" : "")." />
                <label for='all'>".htmlentities($msg['resa_show_all'], ENT_QUOTES, $charset)."</label>
            </span>&nbsp;
            <span class='list_ui_montrerquoi_checkbox ".$this->objects_type."_montrerquoi_checkbox'>
                <input type='radio' name='".$this->objects_type."_montrerquoi' value='validees' id='validees' ".($this->filters['montrerquoi'] == 'validees' ? "checked='checked'" : "")." />
                <label for='validees'>".htmlentities($msg['resa_show_validees'], ENT_QUOTES, $charset)."</label>
            </span>&nbsp;
            <span class='list_ui_montrerquoi_checkbox ".$this->objects_type."_montrerquoi_checkbox'>
                <input type='radio' name='".$this->objects_type."_montrerquoi' value='invalidees' id='invalidees' ".($this->filters['montrerquoi'] == 'invalidees' ? "checked='checked'" : "")." />
                <label for='invalidees'>".htmlentities($msg['resa_show_invalidees'], ENT_QUOTES, $charset)."</label>
            </span>&nbsp;
            <span class='list_ui_montrerquoi_checkbox ".$this->objects_type."_montrerquoi_checkbox'>
                <input type='radio' name='".$this->objects_type."_montrerquoi' value='valid_noconf' id='valid_noconf' ".($this->filters['montrerquoi'] == 'valid_noconf' ? "checked='checked'" : "")." />
                <label for='valid_noconf'>".htmlentities($msg['resa_show_non_confirmees'], ENT_QUOTES, $charset)."</label>
            </span>";
		return $search_filter;
	}
	
	protected function get_search_filter_removal_location() {
		global $msg, $charset;
		
		$query = 'select idlocation, location_libelle FROM docs_location order by location_libelle';
		$result = pmb_mysql_query($query);
		$search_filter = '<select name="'.$this->objects_type.'_removal_location">';
		$search_filter.='<option value="0"'.((!$this->filters['removal_location'])?' selected="selected"':'').'>'.htmlentities($msg["all_location"], ENT_QUOTES, $charset).'</option>';
		if(pmb_mysql_num_rows($result)) {
			while($o=pmb_mysql_fetch_object($result)) {
				$search_filter.= '<option value="'.$o->idlocation.'"'.(($this->filters['removal_location'] == $o->idlocation)?' selected="selected"':'').'>'.htmlentities($o->location_libelle,ENT_QUOTES,$charset).'</option>';
			}
		}
		$search_filter.= '</select>';
		return $search_filter;
	}
	
	protected function get_search_filter_available_location() {
		global $msg, $charset;
		
		$query = 'select idlocation, location_libelle FROM docs_location order by location_libelle';
		$result = pmb_mysql_query($query);
		$search_filter = '<select name="'.$this->objects_type.'_available_location">';
		$search_filter.='<option value="0"'.((!$this->filters['available_location'])?' selected="selected"':'').'>'.$msg['all_location'].'</option>';
		if(pmb_mysql_num_rows($result)) {
			while($o=pmb_mysql_fetch_object($result)) {
				$search_filter.= '<option value="'.$o->idlocation.'"'.(($this->filters['available_location'] == $o->idlocation)?' selected="selected"':'').'>'.htmlentities($o->location_libelle,ENT_QUOTES,$charset).'</option>';
			}
		}
		$search_filter.= '</select>';
		return $search_filter;
	}
	
	protected function get_search_filter_resa_loc_retrait() {
		global $msg, $charset;
		
		$query = 'select idlocation, location_libelle FROM docs_location order by location_libelle';
		$result = pmb_mysql_query($query);
		$search_filter = '<select name="'.$this->objects_type.'_resa_loc_retrait">';
		$search_filter.='<option value="0"'.((!$this->filters['resa_loc_retrait'])?' selected="selected"':'').'>'.$msg['all_location'].'</option>';
		if(pmb_mysql_num_rows($result)) {
			while($o=pmb_mysql_fetch_object($result)) {
				$search_filter.= '<option value="'.$o->idlocation.'"'.(($this->filters['resa_loc_retrait'] == $o->idlocation)?' selected="selected"':'').'>'.htmlentities($o->location_libelle,ENT_QUOTES,$charset).'</option>';
			}
		}
		$search_filter.= '</select>';
		return $search_filter;
	}
	
	/**
	 * Affichage du formulaire de recherche
	 */
	public function get_search_form() {
		$search_form = parent::get_search_form();
		$search_form = str_replace('!!action!!', static::get_controller_url_base(), $search_form);
		return $search_form;
	}
		
	/**
	 * Jointure externes SQL pour les besoins des filtres
	 */
	protected function _get_query_join_filters() {
		global $pmb_location_reservation;
		
		$filter_join_query = '';
		if($pmb_location_reservation && $this->filters['resa_loc_retrait']) {
			$filter_join_query .= " JOIN resa_loc ON empr_location=resa_emprloc";
		}
		return $filter_join_query;
	}
	
	/**
	 * Filtre SQL
	 */
	protected function _get_query_filters() {
		global $pmb_transferts_actif, $transferts_choix_lieu_opac, $transferts_site_fixe;
		global $pmb_location_reservation;
		
		$filter_query = '';
		
		$this->set_filters_from_form();
		
		$filters = array();
		
		if(get_called_class() == 'list_reservations_edition_treat_ui') {
			$filters [] = '(resa_cb="" or resa_cb is null)';
		}
		if($this->filters['id_notice']) {
			$filters [] = 'resa.resa_idnotice="'.$this->filters['id_notice'].'"';
		}
		if($this->filters['id_bulletin']) {
			$filters [] = 'resa.resa_idbulletin="'.$this->filters['id_bulletin'].'"';
		}
		if($this->filters['id_empr']) {
			$filters [] = 'resa.resa_idempr="'.$this->filters['id_empr'].'"';
		}
		if($this->filters['montrerquoi']) {
			switch ($this->filters['montrerquoi']) {
				case 'validees':
					$filters [] = 'resa_cb<>""';
					break;
				case 'invalidees':
					$filters [] = 'resa_cb=""';
					break;
				case 'valid_noconf':
					$filters [] = 'resa_cb<>""';
					$filters [] = 'resa_confirmee="0"';
					break;
				case 'all':
				default:
					break;
			}
		}
		if($this->filters['removal_location']) {
			$filters [] = 'empr_location = "'.$this->filters['removal_location'].'"';
		}
		if($this->filters['available_location']) {
// 			$filters [] = 'expl_location = "'.$this->filters['available_location'].'"';
		}
		if($this->filters['resa_loc_retrait']) {
			if ($pmb_transferts_actif=="1" && $this->filters['resa_loc_retrait']) {
				switch ($transferts_choix_lieu_opac) {
					case "1":
						//retrait de la resa sur lieu choisi par le lecteur
						$filters [] = 'resa_loc_retrait="'.$this->filters['resa_loc_retrait'].'"';
						break;
					case "2":
						//retrait de la resa sur lieu fix
						if ($this->filters['resa_loc_retrait'] != $transferts_site_fixe) {
							$filters [] = '0';
						}
						break;
					case "3":
						//retrait de la resa sur lieu exemplaire
						// On affiche les rsa que peut satisfaire la loc
						// respecter les droits de rservation du lecteur
						if($pmb_location_reservation) {
							$filters [] = 'resa_loc.resa_loc="'.$this->filters['resa_loc_retrait'].'"';
						}
						break;
					default:
						//retrait de la resa sur lieu lecteur
						$filters [] = 'empr_location="'.$this->filters['resa_loc_retrait'].'"';
						break;
				}
			}elseif($pmb_location_reservation && $this->filters['resa_loc_retrait']) {
				$filters [] = 'resa_loc.resa_loc="'.$this->filters['resa_loc_retrait'].'"';
			}
		}
		if($this->filters['resa_state']) {
			switch ($this->filters['resa_state']) {
			    case 'depassee':
			    	$filters [] = '(resa_date_fin < CURDATE() and resa_date_fin<>"0000-00-00")';
			    	break;
				case 'encours':
				default:
					$filters [] = '(resa_date_fin >= CURDATE() or resa_date_fin="0000-00-00")';
			    	break;
			}
// 			$filters [] = $this->filters['resa_dates_restrict'];
		}
		if(count($filters)) {
			$filter_query .= $this->_get_query_join_filters();
			$filter_query .= ' where resa_idempr=empr.id_empr and '.implode(' and ', $filters);		
		}
		return $filter_query;
	}
	
	/**
	 * Fonction de callback
	 * @param object $a
	 * @param object $b
	 */
	protected function _compare_objects($a, $b) {
	    if($this->applied_sort[0]['by']) {
	        $sort_by = $this->applied_sort[0]['by'];
			switch($sort_by) {
				case 'expl_cote':
					return strcmp($a->get_exemplaire()->cote, $b->get_exemplaire()->cote);
					break;
				case 'record' :
					$a_notice_title = reservation::get_notice_title($a->id_notice, $a->id_bulletin);
					$b_notice_title = reservation::get_notice_title($b->id_notice, $b->id_bulletin);
					return strcmp(strip_tags($a_notice_title), strip_tags($b_notice_title));
					break;
				case 'empr':
					return strcmp(emprunteur::get_name($a->id_empr), emprunteur::get_name($b->id_empr));
					break;
				case 'empr_location':
					return strcmp(emprunteur::get_location($a->id_empr)->libelle, emprunteur::get_location($b->id_empr)->libelle);
					break;
				case 'resa_date':
					return strcmp($a->date, $b->date);
					break;
				case 'resa_date_debut':
					return strcmp($a->date_debut, $b->date_debut);
					break;
				case 'resa_date_fin':
					return strcmp($a->date_fin, $b->date_fin);
					break;
				case 'resa_condition': //Situation
					return strcmp(strip_tags($this->get_cell_content_resa_condition($a)), strip_tags($this->get_cell_content_resa_condition($b)));
					break;
				default :
					return parent::_compare_objects($a, $b);
					break;
			}
		}
	}
	
	/**
	 * Construction dynamique de la fonction JS de tri
	 */
	protected function get_js_sort_script_sort() {
		$display = parent::get_js_sort_script_sort();
		$display = str_replace('!!sub!!', '', $display);
		$display = str_replace('!!action!!', 'list', $display);
		return $display;
	}
	
	/**
	 * Objet de la liste
	 */
	protected function get_display_content_object_list($object, $indice) {
		$ancre_aff="";
		if(!empty(static::$ancre) && static::$ancre==$object->id) {
			$ancre_aff=" id='ancre_resa' ";
		}
		$display = "
					<tr $ancre_aff class='".($indice % 2 ? 'odd' : 'even')."' onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='".($indice % 2 ? 'odd' : 'even')."'\">";
		foreach ($this->columns as $column) {
			if($column['html']) {
				$display .= $this->get_display_cell_html_value($object, $column['html']);
			} else {
				$display .= $this->get_display_cell($object, $column['property']);
			}
		}
		$display .= "</tr>";
		if(!empty(static::$ancre) && static::$ancre==$object->id) {
			$display .= "<a name='ancre_resa'></a>";
		}
		return $display;
	}
	
	/**
	 * Affiche la recherche + la liste
	 */
	public function get_display_list() {
		$display = parent::get_display_list();
		if(!empty(static::$ancre)) {
			$display .= "
				<script language=javascript>
					document.location='#ancre_resa';
				</script>
			";
		}
		return $display;
	}
	
	protected function get_resa_situation($object) {
		if(empty($this->resa_situation)) {
			$this->resa_situation = array();
		}
		if(!isset($this->resa_situation[$object->id])) {
			$rank = recupere_rang($object->id_empr, $object->id_notice, $object->id_bulletin, $this->filters['removal_location']);
			
			$resa_situation = new resa_situation($object->id);
			$resa_situation->set_resa($object)
			->set_resa_cb($object->expl_cb)
			->set_idlocation($this->location_reservations[$object->id])
			->set_precedenteresa_idnotice($this->precedenteresa_idnotice)
			->set_precedenteresa_idbulletin($this->precedenteresa_idbulletin)
			->set_rank($rank)
			->set_no_aff($this->no_aff)
			->set_lien_deja_affiche($this->lien_deja_affiche);
			$this->resa_situation[$object->id] = $resa_situation;
		}
		return $this->resa_situation[$object->id];
	}
	
	protected function get_cell_content_resa_condition($object) {
		if(!isset($this->precedenteresa_idnotice)) $this->precedenteresa_idnotice = 0;
		if(!isset($this->precedenteresa_idbulletin)) $this->precedenteresa_idbulletin = 0;
		if(!isset($this->no_aff)) $this->no_aff = 0;
		if(!isset($this->no_aff)) $this->lien_deja_affiche = 0;
		
		$resa_situation = $this->get_resa_situation($object);
		$situation = $resa_situation->get_display();
		
		$this->precedenteresa_idnotice = $resa_situation->get_precedenteresa_idnotice();
		$this->precedenteresa_idbulletin = $resa_situation->get_precedenteresa_idbulletin();
		$this->no_aff = $resa_situation->get_no_aff();
		$this->lien_deja_affiche = $resa_situation->get_lien_deja_affiche();
		
		return $situation;
	}
	
	protected function get_cell_content($object, $property) {
		global $base_path;
		
		$content = '';
		switch($property) {
			case 'expl_cb':
				$content .= exemplaire::get_cb_link($object->{$property});
				break;
			case 'expl_cote':
				$content .= $object->get_exemplaire()->cote;
				break;
			case 'record':
				if ($object->id_bulletin) {
					$typdoc = "";
				} else {
					$typdoc = notice::get_typdoc($object->id_notice);
				}
				$content .= resa_list_get_column_title($object->id_notice, $object->id_bulletin, $typdoc);
				break;
			case 'empr':
				if (SESSrights & CIRCULATION_AUTH) {
					$content .= "<a href='".$base_path."/circ.php?categ=pret&form_cb=".rawurlencode(emprunteur::get_cb_empr($object->id_empr))."'>".emprunteur::get_name($object->id_empr)."</a>";
				} else {
					$content .= emprunteur::get_name($object->id_empr);
				}
				break;
			case 'empr_location':
				$content .= emprunteur::get_location($object->id_empr)->libelle;
				break;
			case 'rank':
				$content .= recupere_rang($object->id_empr, $object->id_notice, $object->id_bulletin, $this->filters['removal_location']) ;
				break;
			case 'resa_date':
				$content .= $object->formatted_date;
				break;
			case 'resa_date_debut':
				if($object->date_debut != '0000-00-00') {
					$content .= $object->formatted_date_debut;
				}
				break;
			case 'resa_date_fin':
				if($object->date_fin != '0000-00-00') {
					$content .= $object->formatted_date_fin;
				}
				break;
			case 'resa_validee':
				if($object->expl_cb) {
					$content .= "<span style='color:red'>X</span>";
				}
				break;
			case 'resa_confirmee':
				if($object->confirmee) {
					$content .= "<span style='color:red'>X</span>";
				}
				break;
			case 'resa_loc_retrait':
				$loc_retrait = resa_loc_retrait($object->id);
				$docs_location = new docs_location($loc_retrait);
				$content .= $docs_location->libelle;
				break;
			case 'resa_condition': //Situation
				$content .= $this->get_cell_content_resa_condition($object);
				break;
			case 'expl_location':
				$content .= $object->get_exemplaire()->location;
				break;
			case 'support':
				$content .= $object->get_exemplaire()->typdoc;
				break;
			case 'statut':
				$docs_statut = new docs_statut($object->get_exemplaire()->statut_id);
				$content .= $docs_statut->libelle;
				break;
			case 'section':
				$content .= $object->get_exemplaire()->{$property};
				break;
			default :
				$content .= parent::get_cell_content($object, $property);
				break;
		}
		return $content;
	}
	
	protected function _get_query_human() {
		global $msg;
		
		$humans = array();
		if($this->filters['montrerquoi']) {
			switch ($this->filters['montrerquoi']) {
				case 'validees':
					$humans[] = $this->_get_label_query_human($msg['empr_etat_resa_query'], $msg['resa_show_validees']);
					break;
				case 'invalidees':
					$humans[] = $this->_get_label_query_human($msg['empr_etat_resa_query'], $msg['resa_show_invalidees']);
					break;
				case 'valid_noconf':
					$humans[] = $this->_get_label_query_human($msg['empr_etat_resa_query'], $msg['resa_show_non_confirmees']);
					break;
			}
		}
		if($this->filters['removal_location']) {
			$docs_location = new docs_location($this->filters['removal_location']);
			$humans[] = $this->_get_label_query_human($msg['transferts_circ_resa_lib_localisation'], $docs_location->libelle);
		}
		if($this->filters['available_location']) {
			$docs_location = new docs_location($this->filters['available_location']);
			$humans[] = $this->_get_label_query_human($msg['edit_resa_expl_available_filter'], $docs_location->libelle);
		}
		if($this->filters['resa_loc_retrait']) {
			$docs_location = new docs_location($this->filters['resa_loc_retrait']);
			$humans[] = $this->_get_label_query_human($msg['edit_resa_expl_location_filter'], $docs_location->libelle);
		}
		return $this->get_display_query_human($humans);
	}
	
	public static function set_ancre($ancre) {
		static::$ancre = intval($ancre);
	}
}