<?php
// +-------------------------------------------------+
// | 2002-2007 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: transferts.class.php,v 1.1.2.3 2020/10/16 08:44:36 dgoron Exp $

if (stristr ( $_SERVER ['REQUEST_URI'], ".class.php" )) die ( "no access" );

global $include_path;
require_once ("$include_path/templates/transferts.tpl.php");

class transferts {
		
	protected static $sub;
	
	protected static $params;
	
	// constructeur
	public function __construct() {
	}
	
	protected static function add_separator_param($label_code) {
		global $msg;
		
		static::$params[static::$sub][] = array (
			"separator" => $msg[$label_code]
		);
	}
	
	protected static function add_param($name, $label_code, $type, $val=array(), $params='') {
		global $msg;
		
		static::$params[static::$sub][] = array (
				"prefix" => "transferts",
				"nom" => $name,
				"lib" => $msg[$label_code],
				"champ" => "admin_".$name,
				"type" => $type,
				"val" => $val,
				"params" => $params
		);
	}
	
	protected static function add_selector_param($name, $label_code, $val = array()) {
		global $msg;
		
		if(empty($val)) {
			$val = array (
					array ("valeur" => "0", "lib" => $msg["39"] ),
					array ("valeur" => "1", "lib" => $msg["40"] )
			);
		}
		static::add_param($name, $label_code, 'select', $val);
	}
	
	protected static function add_selector_status_param($name, $label_code, $empty_label_code='') {
		global $msg;
		
		$val = array();
		if($empty_label_code) {
			$val[] = array(
				"valeur" => "0",
				"lib" => $msg[$empty_label_code]
			);
		}
		$val[] = array (
				"liste" => "SELECT idstatut, statut_libelle FROM docs_statut order by statut_libelle",
				"affichage" => "SELECT statut_libelle FROM docs_statut WHERE idstatut=!!id!!" 
		);
		static::add_selector_param($name, $label_code, $val);
	}
	
	protected static function add_text_param($name, $label_code, $size=2, $maxlength=3) {
		$params = "size='".$size."' maxlength='".$maxlength."'";
		static::add_param($name, $label_code, 'text', array(), $params);
	}
	
	protected static function init_general_params() {
		//Activation de l'tape de validation
		static::add_selector_param('validation_actif', 'admin_transferts_lib_active_validation');
		//Regrouper la gestion des dparts: Validation, envoi, retour
		static::add_selector_param('regroupement_depart', 'admin_transferts_regroupement_depart');
		//Nb de jours de dpt par dfaut
		static::add_text_param('nb_jours_pret_defaut', 'admin_transferts_lib_nb_jours_pret');
		//Statut de l'exemplaire aprs validation
		static::add_selector_status_param('statut_validation', 'admin_transferts_lib_statut_validation', 'admin_transferts_lib_statut_validation_pas_chg');
		//Appliquer ce statut avant la validation
		static::add_selector_param('pret_demande_statut', 'admin_transferts_pret_demande_statut');
		//Statut de l'exemplaire pendant le transfert
		static::add_selector_status_param('statut_transferts', 'admin_transferts_lib_statut_transfert');
		//Activer les exemplaires fantmes
		static::add_selector_param('ghost_expl_enable', 'admin_transferts_lib_activate_ghost_expl');
		//Choix du script de gnration des codes barres des exemplaires fantmes
		static::add_text_param('ghost_expl_gen_script', 'admin_transferts_lib_ghost_expl_gen_script', 30, 60);
		//Statut de l'exemplaire fantme
		static::add_selector_status_param('ghost_statut_expl_transferts', 'admin_transferts_lib_statut_ghost_transfert');
		//Afficher la source et la destination en dition
		static::add_selector_param('edition_show_all_colls', 'admin_transferts_lib_edition_show_all_colls');
	}
	
	protected static function init_circ_params() {
		global $msg;
		
		//Nb de lignes par page
		static::add_text_param('tableau_nb_lignes', 'admin_transferts_lib_nb_lignes');
		//Nombre de jours avant que l'alerte ne s'affiche en retour
		static::add_text_param('nb_jours_alerte', 'admin_transferts_lib_nb_jours_alerte');
		//Autorise le traitement par lot en envoi
		static::add_selector_param('envoi_lot', 'admin_transferts_lib_envoi_lot');
		//Autorise le traitement par lot en reception
		static::add_selector_param('reception_lot', 'admin_transferts_lib_reception_lot');
		//Autorise le traitement par lot pour les retours
		static::add_selector_param('retour_lot', 'admin_transferts_lib_retour_lot');
		
		static::add_separator_param('admin_transferts_sep_pret_exemplaire');
		
		//Action par dfaut si le document est en transfert
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_lib_pret_statut_transfert_non"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_lib_pret_statut_transfert_oui"] )
		);
		static::add_selector_param('pret_statut_transfert', 'admin_transferts_lib_pret_statut_transfert', $val);
		
		static::add_separator_param('admin_transferts_sep_retour_exemplaire');
		//Empcher le retour de l'exemplaire sur un site autre que le sien
		static::add_selector_param('retour_origine', 'admin_transferts_lib_force_retour_origine');
		//Autoriser  forcer le retour de l'exemplaire sur un site autre que le sien
		static::add_selector_param('retour_origine_force', 'admin_transferts_lib_force_retour_origine_autorise');
		
		//Action par dfaut lors d'un retour sur un autre site
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_lib_retour_action_plus_tard"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_lib_retour_action_loc"] ),
				array ("valeur" => "2", "lib" => $msg ["admin_transferts_lib_retour_action_trans"] )
		);
		static::add_selector_param('retour_action_defaut', 'admin_transferts_lib_retour_action_defaut', $val);
		//Autorise une autre action que celle par dfaut
		static::add_selector_param('retour_action_autorise_autre', 'admin_transferts_lib_retour_autorise_autre');
		
		//Sauvegarder l'ancienne localisation en cas de changement de localisation au retour
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_lib_retour_loc_pas_sauv"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_lib_retour_loc_sauv"] )
		);
		static::add_selector_param('retour_change_localisation', 'admin_transferts_lib_retour_loc', $val);
		//Etat du transfert gnr
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_lib_retour_trans_creer"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_lib_retour_trans_envoi"] )
		);
		static::add_selector_param('retour_etat_transfert', 'admin_transferts_lib_retour_trans', $val);
		//Motif du transfert gnr automatiquement
		static::add_text_param('retour_motif_transfert', 'admin_transferts_lib_motif_transfert', 40, 65535);
		
		//Gnre un transfert pour rpondre  une rservation
		static::add_selector_param('retour_action_resa', 'admin_transferts_lib_retour_action_resa');
	}
	
	protected static function init_opac_params() {
		global $msg;
		
		//Choix pour la rservation
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_opac_site_util"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_opac_site_choix"] ),
				array ("valeur" => "2", "lib" => $msg ["admin_transferts_opac_site_precise"] ),
				array ("valeur" => "3", "lib" => $msg ["admin_transferts_opac_site_ex"] )
		);
		static::add_selector_param('choix_lieu_opac', 'admin_transferts_lib_choix_opac', $val);
		
		//Site si lieu fixe prcis
		$val = array (
				array (
						"liste" => "SELECT idlocation,location_libelle FROM docs_location",
						"affichage" => "SELECT location_libelle FROM docs_location WHERE idlocation=!!id!!"
				)
		);
		static::add_selector_param('site_fixe', 'admin_transferts_lib_site_fixe', $val);
		
		//Motif du transfert gnr automatiquement
		static::add_text_param('resa_motif_transfert', 'admin_transferts_lib_motif_transfert_resa', 40, 65535);
		
		//Type du transfert gnr
		$val = array (
				array ("valeur" => "0", "lib" => $msg ["admin_transferts_lib_retour_trans_creer"] ),
				array ("valeur" => "1", "lib" => $msg ["admin_transferts_lib_retour_trans_envoi"] )
		);
		static::add_selector_param('resa_etat_transfert', 'admin_transferts_lib_etat_trans_resa', $val);
	}
	
	public static function init_params() {
		if(empty(static::$params[static::$sub])) {
			static::$params[static::$sub] = array();
		}
		switch (static::$sub) {
			case 'general':
				static::init_general_params();
				break;
			case 'circ':
				static::init_circ_params();
				break;
			case 'opac':
				static::init_opac_params();
				break;
		}
	}
	
	public static function get_display_separator($label) {
		return "
			<tr>
				<th colspan=2>".$label."</th>
			</tr>";
	}
	
	public static function get_display_parameters() {
		global $msg, $charset;
		global $transferts_admin_tableau_modif, $transferts_admin_ligne_modif;
		//initialisation des variables
		$nb = 0;
		$lignesTableau = "";
		
		$display = $transferts_admin_tableau_modif;
		$tab_ligne= $transferts_admin_ligne_modif;
		foreach (static::$params[static::$sub] as $param) {
			if (!isset($param["separator"])) $param["separator"] = '';
			if (!isset($param["params"])) $param["params"] = '';
			if ($param["separator"]!="") {
				$tmpLigne = static::get_display_separator($param["separator"]);
			} else {
				//pour alterner le styles des lignes
				$tmpLigne = str_replace("!!class_ligne!!",($nb%2 ? "odd" : "even"),$tab_ligne);
				//le libelle du parametre
				$tmpLigne = str_replace("!!lib_param!!",$param["lib"],$tmpLigne);
				$tmpLigne = str_replace("!!nom_champ!!",$param["champ"],$tmpLigne);
						
				//en fonction du type on affiche la valeure
				switch ($param["type"]) {
					
					//pour un champ texte
					case "text":
						$varGlobal= $param["prefix"]."_".$param["nom"];
						global ${$varGlobal};
						$tmpInput = "<input type=\"text\" class=\"\" name=\"".$param["champ"]."\" value=\"".htmlentities(${$varGlobal}, ENT_QUOTES, $charset)."\" ".$param["params"].">";
						$tmpLigne = str_replace("!!input_param!!",$tmpInput, $tmpLigne);
						break;
						
						//pour une liste de valeurs fixes
					case "select":
						$varGlobal = $param["prefix"]."_".$param["nom"];
						global ${$varGlobal};
						
						$tmpInput = "<select name='".$param["champ"]."' ".$param["params"].">";
						foreach($param["val"] as $lgOpt) {
							if (!isset($lgOpt["valeur"])) $lgOpt["valeur"] = '';
							if ($lgOpt["valeur"]!="") {
								$tmpInput .= "<option value='".$lgOpt["valeur"]."'";
								if (${$varGlobal}==$lgOpt["valeur"])
									$tmpInput .= " selected";
									$tmpInput .= ">".$lgOpt["lib"]."</option>";
							} else {
								$res = pmb_mysql_query($lgOpt["liste"]);
								while($val = pmb_mysql_fetch_array($res)) {
									$tmpInput .= "<option value='".$val[0]."'";
									if (${$varGlobal}==$val[0])
										$tmpInput .= " selected";
										$tmpInput .= ">".$val[1]."</option>";
								}
							}
						}
						$tmpInput .= "</select>";
						
						$tmpLigne = str_replace("!!input_param!!", $tmpInput, $tmpLigne);
						break;
				}
			}
			//on ajoute la ligne aux autres
			$lignesTableau .= $tmpLigne;
			$nb++;
		}
		
		//on met les lignes dans le tableau
		$display = str_replace("!!liste_lignes!!",$lignesTableau, $display);
		
		//on precise quels parametres pour la modif
		$display = str_replace("!!sub!!", static::$sub, $display);
		$display = str_replace("!!titre!!", $msg["admin_tranferts_" . static::$sub], $display);
		
		return $display;
		
	}
	
	public static function check_loc_retrait_resas($new_choix_lieu_opac) {
		//Si le slecteur "Choix pour la rservation" a chang de valeur, et qu'on est pass en "Choix de la localisation",
		// il faut valoriser le champ resa_loc_retrait s'il est vide, pour les rservations dj cres
		if ($new_choix_lieu_opac == 1) { //Choix pour la rservation
			$query = "SELECT valeur_param FROM parametres WHERE type_param='transferts' AND sstype_param='choix_lieu_opac'";
			$res = pmb_mysql_query($query);
			$old_choix_lieu_opac = pmb_mysql_result($res, 0);
			if ($old_choix_lieu_opac != $new_choix_lieu_opac) {
				//On va donc mettre  jour avec la loc du lecteur
				$query = "SELECT * FROM resa WHERE resa_loc_retrait = 0";
				$res = pmb_mysql_query($query);
				if (pmb_mysql_num_rows($res)) {
					while ($row = pmb_mysql_fetch_object($res)) {
						$query_empr = "SELECT empr_location FROM empr WHERE id_empr=".$row->resa_idempr;
						$res_empr = pmb_mysql_query($query_empr);
						$loc_empr = pmb_mysql_result($res_empr, 0);
						$query_update = "UPDATE resa SET resa_loc_retrait=".$loc_empr." WHERE id_resa = ".$row->id_resa;
						pmb_mysql_query($query_update);
						$query_update = "UPDATE resa_archive, resa SET resarc_loc_retrait=".$loc_empr." WHERE id_resa = ".$row->id_resa." AND resa_arc = resarc_id";
						pmb_mysql_query($query_update);
					}
				}
			}
		}
	}
	
	//enregistre les parametres
	public static function save_parameters() {
		
		foreach (static::$params[static::$sub] as $param ) {
			$varGlobal = $param["prefix"]."_".$param["nom"];
			global ${$varGlobal};
			global ${$param["champ"]};
			
			$val_saisie = ${$param["champ"]};
			
			//on enregistre dans la variable globale
			${$varGlobal} = stripslashes($val_saisie);
			//puis dans la base
			$rqt = "UPDATE parametres SET valeur_param='".$val_saisie."'
					WHERE type_param='".$param["prefix"]."' AND sstype_param='".$param["nom"]."'";
			pmb_mysql_query( $rqt );
		}
	}
	
	//affiche le tableau des localisations pour modifier l'ordre
	public static function get_display_location_order() {
		//les templates
		global $transferts_admin_modif_ordre_loc;
		global $transferts_admin_modif_ordre_loc_ligne;
		global $transferts_admin_modif_ordre_loc_ligne_flBas;
		global $transferts_admin_modif_ordre_loc_ligne_flHaut;
		
		//on genere le tableau des sites
		$rqt = "SELECT idlocation,location_libelle,transfert_ordre FROM docs_location ORDER BY transfert_ordre, idLocation";
		$res = pmb_mysql_query($rqt);
		
		//le nb de lignes
		$nb=0;
		$nbTotal = pmb_mysql_num_rows($res);
		$tmpString = "";
		
		while ($value = pmb_mysql_fetch_array($res)) {
			
			//la classe de la ligne
			if ($nb % 2)
				$tmpLigne = str_replace('!!class_ligne!!', "even", $transferts_admin_modif_ordre_loc_ligne);
				else
					$tmpLigne = str_replace('!!class_ligne!!', "odd", $transferts_admin_modif_ordre_loc_ligne);
					
					//le libell du site
					$tmpLigne = str_replace('!!lib_site!!', $value[1], $tmpLigne);
					
					if ($nb==0) {
						//on est sur la premiere ligne
						if ($nbTotal>1) {
							//on a plus d'une ligne
							$tmpLigne = str_replace("!!fl_bas!!",str_replace("!!idSite!!",$value[0],$transferts_admin_modif_ordre_loc_ligne_flBas),$tmpLigne);
						} else {
							$tmpLigne = str_replace("!!fl_bas!!","",$tmpLigne);
						}
						$tmpLigne = str_replace("!!fl_haut!!","",$tmpLigne);
						
					} else {
						if ($nb==($nbTotal-1)) {
							//on est sur la derniere ligne
							$tmpLigne = str_replace("!!fl_bas!!","",$tmpLigne);
							$tmpLigne = str_replace("!!fl_haut!!",str_replace("!!idSite!!",$value[0],$transferts_admin_modif_ordre_loc_ligne_flHaut),$tmpLigne);
						} else {
							//on est sur ligne du milieu
							$tmpLigne = str_replace("!!fl_bas!!",str_replace("!!idSite!!",$value[0],$transferts_admin_modif_ordre_loc_ligne_flBas),$tmpLigne);
							$tmpLigne = str_replace("!!fl_haut!!",str_replace("!!idSite!!",$value[0],$transferts_admin_modif_ordre_loc_ligne_flHaut),$tmpLigne);
						}
					}
					
					//on verifie que l'ordre est respect
					if ($value[2]!=$nb) {
						//on met a jour le no d'ordre
						$rqt = "UPDATE docs_location SET transfert_ordre=".$nb." WHERE idlocation=".$value[0];
						pmb_mysql_query($rqt);
					}
					
					$nb++;
					$tmpString .= $tmpLigne;
					
		}
		
		//on insere la liste dans le template global
		$tmpString = str_replace("!!liste_sites!!",$tmpString,$transferts_admin_modif_ordre_loc);
		
		return $tmpString;
	}
	
	//change l'ordre de la localisation
	public static function save_location_order($sens, $id) {
		
		//on recuper l'ordre
		$rqt = "SELECT transfert_ordre FROM docs_location WHERE idlocation=".$id;
		$ordreBase = pmb_mysql_fetch_array( pmb_mysql_query( $rqt ) );
		
		//on recupere l'id de la 2eme localisation
		$rqt = "SELECT idLocation FROM docs_location WHERE transfert_ordre=".($ordreBase[0] + $sens);
		$idSecond = pmb_mysql_fetch_array( pmb_mysql_query( $rqt ) );
		
		//on met a jour l'ordre
		$rqt = "UPDATE docs_location SET transfert_ordre=".($ordreBase[0] + $sens)." WHERE idLocation=".$id;
		pmb_mysql_query( $rqt );
		
		//puis celui du 2eme
		$rqt = "UPDATE docs_location SET transfert_ordre=".$ordreBase[0]." WHERE idLocation=".$idSecond[0];
		pmb_mysql_query( $rqt );
	}
	
	//affiche la liste des sites avec leur statut par dfaut
	public static function get_display_list_default_statuses() {
		global $transferts_admin_statuts_loc_liste;
		global $transferts_admin_statuts_loc_ligne;
		global $msg;
		
		// la liste des sites
		$rqt = "SELECT idlocation,location_libelle,statut_libelle FROM docs_location LEFT JOIN docs_statut ON idstatut=transfert_statut_defaut";
		$res = pmb_mysql_query($rqt);
		$tmpOpt = "";
		$nb = 0;
		while ($value = pmb_mysql_fetch_array($res)) {
			//on boucle sur les localisations
			if ($nb%2)
				$tmpString = str_replace("!!class_ligne!!","odd",$transferts_admin_statuts_loc_ligne);
				else
					$tmpString = str_replace("!!class_ligne!!","even",$transferts_admin_statuts_loc_ligne);
					
					//l'id du site
					$tmpString = str_replace("!!id_site!!",$value[0],$tmpString);
					
					//le libell du statut
					if ($value[2] != "")
						$tmpString = str_replace("!!nom_statut!!", $value[2], $tmpString);
						else
							$tmpString = str_replace("!!nom_statut!!", $msg["admin_transferts_statut_transfert_non_defini"], $tmpString);
							
							//le nom du site
							$tmpOpt .= str_replace("!!nom_site!!",$value[1],$tmpString);
							
							$nb++;
		}
		$tmpString = str_replace("!!liste_sites!!", $tmpOpt, $transferts_admin_statuts_loc_liste);
		return $tmpString;
	}
	
	//affiche l'cran de modification du statut par dfaut d'un site
	public static function get_display_default_status($id) {
		global $transferts_admin_statuts_loc_modif;
		
		//la requete
		$rqt = "SELECT idlocation, location_libelle, transfert_statut_defaut FROM docs_location WHERE idlocation=".$id;
		$res = pmb_mysql_query($rqt);
		$value = pmb_mysql_fetch_array($res);
		
		//on remplace dans le template
		$tmpString = str_replace("!!nom_site!!",$value[1],$transferts_admin_statuts_loc_modif);
		$tmpString = str_replace("!!id_site!!",$value[0],$tmpString);
		$tmpString = str_replace("!!selStatut!!",$value[2],$tmpString);
		
		//la liste des statuts
		$rqt = "SELECT idstatut, statut_libelle FROM docs_statut order by statut_libelle";
		$res = pmb_mysql_query($rqt);
		$tmpOpt = "";
		while ($value = pmb_mysql_fetch_array($res)) {
			$tmpOpt .= "<option value='" . $value[0] . "'>" . $value[1] . "</option>";
		}
		$tmpString = str_replace("!!liste_statuts!!", $tmpOpt, $tmpString);
		
		return $tmpString;
	}
	
	//enregistre le nouveau statut par dfaut d'un site
	public static function save_default_status($id, $statut) {
		//on met  jour l'enregistrement
		$rqt = "UPDATE docs_location SET transfert_statut_defaut=".$statut." WHERE idlocation=".$id;
		pmb_mysql_query( $rqt );
	}
	
	public static function get_display_purge($date_purge=null) {
		global $transferts_admin_purge_defaut;
		global $msg;
		
		if ($date_purge==null) {
			$tmpString = str_replace("!!message_purge!!", "", $transferts_admin_purge_defaut);
		} else {
			$tmpString = str_replace("!!date_purge!!",formatdate($date_purge),$msg["admin_transferts_message_purge"]);
			$tmpString = str_replace("!!message_purge!!", $tmpString, $transferts_admin_purge_defaut);
		}
		
		//on met la date du jour
		$date_purge_dt = mktime(0, 0, 0, date("m"), date("d"), date("Y"));
		$date_purge_aff = date("Y-m-d", $date_purge_dt);
		$tmpString = str_replace("!!date_purge_mysql!!", $date_purge_aff, $tmpString);
		$date_purge_aff = date("d/m/Y", $date_purge_dt);
		$tmpString = str_replace("!!date_purge!!", $date_purge_aff, $tmpString);
		
		return $tmpString;
	}
	
	//purge l'historique des transferts
	public static function admin_purge_historique($datefin) {
		$rqt = "DELETE transferts.*, transferts_demande.*
				FROM transferts INNER JOIN transferts_demande
				WHERE transferts.etat_transfert=1 AND transferts.date_creation<'".$datefin."' AND num_transfert=id_transfert";
		pmb_mysql_query( $rqt );
	}
	
	public static function set_sub($sub) {
		static::$sub = $sub;
	}
}

?>