<?php
// +-------------------------------------------------+
//  2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: onto_contribution_datatype_linked_record_selector.class.php,v 1.1.6.3 2020/09/22 12:06:48 qvarin Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once $class_path.'/onto/common/onto_common_datatype.class.php';


/**
 * class onto_common_datatype_resource_selector
 * Les mthodes get_form,get_value,check_value,get_formated_value,get_raw_value
 * sont ventuellement  redfinir pour le type de donnes
 */
class onto_contribution_datatype_linked_record_selector  extends onto_common_datatype {

	/** Aggregations: */

	/** Compositions: */

	 /*** Attributes: ***/
	
	/**
	 *
	 * @access public
	 */

	public function check_value(){
		if (is_string($this->value)) return true;
		return false;
	}
	
	public function get_value(){
		return $this->value;
	} 
	
	public function get_formated_value(){
	    if (isset($this->formated_value)) {
	        return $this->formated_value;
	    }
	    $this->formated_value = $this->value;
	    $assertions = $this->offsetget_value_property("assertions");
	    if (is_array($assertions)) {
	        $this->formated_value = array();
	        /* @var $assertion onto_assertion */
	        foreach ($assertions as $assertion) {
	            switch ($assertion->get_predicate()) {
	                case 'http://www.pmbservices.fr/ontology#relation_type' :
	                    $this->formated_value['relation_type'] = $assertion->get_object();
	                    break;
	                case 'http://www.pmbservices.fr/ontology#has_record' :
	                    $properties = static::get_properties_from_uri($assertion->get_object());
	                    $this->formated_value['record'] = array(
                                'value' => $assertion->get_object(),
    	                        'display_label' => $assertion->offset_get_object_property('display_label'),
    	                        'area_id' => $properties["http://www.pmbservices.fr/ontology#area"],
    	                        'form_uri' => $properties["http://www.pmbservices.fr/ontology#form_uri"] ?? "",
    	                        'form_id' => $properties["http://www.pmbservices.fr/ontology#form_id"] ?? 0,
                                'is_draft' => ($properties["http://www.pmbservices.fr/ontology#is_draft"] == true ? "1" : "0")
	                    );
	                    break;
	            }
	        }
	    }
		return $this->formated_value;
	}
	
	public function get_value_type() {
	    return 'http://www.pmbservices.fr/ontology#linked_record';
	}
	
	public static function get_values_from_form($instance_name, $property, $uri_item) {
	    global $opac_url_base;
	    $datatypes = array();
	    $var_name = $instance_name."_".$property->pmb_name;
	    global ${$var_name};
	    if (${$var_name} && count(${$var_name})) {
	        foreach (${$var_name} as $order => $data) {
	            $data=stripslashes_array($data);
	            if (($data["value"] !== null) && ($data["value"] !== '')) {
	                $data_properties = array();
	                if (!empty($data["lang"])) {
	                    $data_properties["lang"] = $data["lang"];
	                } else {
	                    $data_properties["lang"] = '';
	                }
	                if ($data["type"] == "http://www.w3.org/2000/01/rdf-schema#Literal") {
	                    $data_properties["type"] = "literal";
	                } else {
	                    $data_properties["type"] = "uri";
	                }
	                if ($data["display_label"]) {
	                    $data_properties["display_label"] = $data["display_label"];
	                }
	                
	                $responsablity_uri = onto_common_uri::get_new_uri($opac_url_base."linked_record#");
	                $data_properties["object_assertions"] = array(
	                    new onto_assertion($responsablity_uri, 'http://www.pmbservices.fr/ontology#has_record', $data["value"], "http://www.pmbservices.fr/ontology#record", array('type'=>"uri", "display_label" => $data_properties["display_label"])),
	                    new onto_assertion($responsablity_uri, 'http://www.pmbservices.fr/ontology#relation_type', $data["relation_type"], "", array('type'=>"literal"))
	                );
	                $class_name = static::class;
	                //$datatypes[$property->uri][] = new $class_name($responsablity_uri, $data["type"], $data_properties);
	                $datatypes[$property->uri][] = new $class_name($responsablity_uri, 'http://www.pmbservices.fr/ontology#responsability', $data_properties);
	            }
	        }
	    }
	    return $datatypes;
	}
 
} // end of onto_common_datatype_resource_selector
