<?php
// +-------------------------------------------------+
// � 2002-2011 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: onto_contribution_datatype_resource_selector_ui.class.php,v 1.15.2.22 2020/10/22 09:08:57 jlaurent Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once $class_path.'/onto/common/onto_common_datatype_resource_selector_ui.class.php';

/**
 * class onto_contribution_datatype_resource_selector_ui
 * 
 */
class onto_contribution_datatype_resource_selector_ui extends onto_common_datatype_resource_selector_ui {
	
	/**
	 *
	 *
	 * @param onto_common_property $property la proprit concerne
	 * @param onto_restriction $restrictions le tableau des restrictions associes  la proprit
	 * @param array datas le tableau des datatypes
	 * @param string instance_name nom de l'instance
	 * @param string flag Flag
	
	 * @return string
	 * @static
	 * @access public
	 */
	public static function get_form($item_uri, $property, $restrictions, $datas, $instance_name, $flag) {
		global $msg,$charset,$ontology_tpl, $area_id;
		
		//gestion des droits
		global $gestion_acces_active, $gestion_acces_empr_contribution_scenario;
		if (($gestion_acces_active == 1) && ($gestion_acces_empr_contribution_scenario == 1)) {
			$ac = new acces();
			$dom_5 = $ac->setDomain(5);
		}
	
		$form=$ontology_tpl['form_row'];
		$form=str_replace("!!onto_row_label!!",htmlentities(encoding_normalize::charset_normalize($property->get_label(), 'utf-8') ,ENT_QUOTES,$charset) , $form);
		/** traitement initial du range ?!*/
		$range_for_form = "";
		if(is_array($property->range)){
			foreach($property->range as $range){
				if($range_for_form) $range_for_form.="|||";
				$range_for_form.=$range;
			}
		} else {
			$range_for_form = $property->range;
		}
	
		$content = '';
		$add_button = '';
		if ($restrictions->get_max() === -1) {			
			$add_button = $ontology_tpl['form_row_content_input_add_resource_selector'];
		}
		$content = str_replace("!!property_name!!", rawurlencode($property->pmb_name), $content);
		
		if (!empty($datas)) {
			$i = 1;
// 			$first = true;
			$new_element_order = max(array_keys($datas));
				
			$form = str_replace("!!onto_new_order!!", $new_element_order, $form);
				
			foreach($datas as $key => $data){
				$row=$ontology_tpl['form_row_content_with_flex'];
	
				if($data->get_order()){
					$order=$data->get_order();
				}else{
					$order=$key;
				}
				
				$management_data = $data->get_management_data();
				
				$inside_row=$ontology_tpl['form_row_content_resource_selector'];
				$inside_row .= $ontology_tpl['form_row_content_type'];
				$inside_row=str_replace("!!form_row_content_resource_selector_display_label!!",htmlentities(addslashes($data->get_formated_value()),ENT_QUOTES,$charset), $inside_row);
				$inside_row=str_replace("!!form_row_content_resource_selector_value!!",$data->get_value(), $inside_row);
				$inside_row=str_replace("!!form_row_content_resource_selector_is_draft!!", (isset($management_data['is_draft']) ? $management_data['is_draft'] : ""), $inside_row);
				$inside_row=str_replace("!!onto_row_content_range!!",$data->get_value_type() , $inside_row);
				$inside_row=str_replace("!!onto_current_element!!",onto_common_uri::get_id($item_uri),$inside_row);
				$inside_row=str_replace("!!onto_current_range!!",$range_for_form,$inside_row);
	
				$class = "";
				if (!empty($management_data['is_draft']) && $management_data['is_draft']) {
				    $class = "contribution_draft";
				}
				$row = str_replace("!!onto_row_is_draft!!", $class, $row);
				$row=str_replace("!!onto_inside_row!!",$inside_row , $row);
	
				$input='';
// 				if($first){
					$input.=$ontology_tpl['form_row_content_input_remove'];
// 				}else{
// 					$input.=$ontology_tpl['form_row_content_input_del'];
// 				}
				$input.=$ontology_tpl['form_row_content_search'];
				
				$params = [];
				$params['type'] = self::get_type_from_range($property->range[0]);
				$params['sub_form'] = 1;
				$params['is_draft'] = $property->is_draft ?? 0;
				
				if ($property->has_linked_form) {
				    $linked_forms = false;
				    foreach ($property->linked_forms as $linked_form){
				        if (!empty($management_data['form_uri']) && $linked_form['form_id_store'] == $management_data['form_uri']) {
				            $linked_forms = true;
				        }
				    }
				    
				    //Onglet modifier
				    if ($linked_forms && $management_data['value']) {
				        //Onglet modifier
				        $input .= $ontology_tpl['form_row_content_edit'];
				        $url = static::get_edit_url($management_data, $property->linked_forms[0]['scenario_id'], $params['type'], $params) ;
				        $input = str_replace("!!url_edit_form!!", $url, $input);
				    } else {
				        $input .= $ontology_tpl['form_row_content_edit_hidden'];
				    }
				    $params['edit_contribution'] = 0;
				    
				    $access_granted = true;
				    
				    if (onto_common_uri::is_temp_uri($item_uri)) {
				        //droit de creation
				        $acces_right = 4;
				    } else {
				        //droit de modification
				        $acces_right = 8;
				    }
				    
				    if (isset($dom_5) && !$dom_5->getRights($_SESSION['id_empr_session'],onto_common_uri::get_id($property->linked_form['scenario_uri']), $acces_right)) {
				        $access_granted = false;
				    }
				    if ($access_granted) {
				        $input .= $ontology_tpl['form_row_content_linked_form'];
				        
				        $params['area_id'] = $property->linked_forms[0]['area_id'] ?? 0;
				        $params['id'] = 0;
				        $params['form_id'] = $property->linked_forms[0]['form_id'] ?? 0;
				        $params['form_uri'] = isset($property->linked_forms[0]['form_id_store']) ? urlencode($property->linked_forms[0]['form_id_store']) : "";
				        $params['select_tab'] = 1;
				        $params['create'] = 1;
				        $params['scenario'] = $property->linked_forms[0]['scenario_id'] ?? 0;
				        $params['multiple_scenarios'] = $property->has_multiple_scenarios;
				        $params['attachment'] = $property->linked_forms[0]['attachment_id'] ?? 0;
				        
				        $json_data = encoding_normalize::json_encode($params);
				        $url = "./select.php?what=contribution&selector_data=".urlencode($json_data);
				        $input = str_replace("!!url_linked_form!!", $url, $input);
				    }
				    $input = str_replace("!!linked_scenario!!", $property->linked_forms[0]['scenario_id'] ?? 0, $input);
				}
				
				$params['select_tab'] = 0;
				$json_data = encoding_normalize::json_encode($params);
				$url_search = "./select.php?what=contribution&selector_data=".urlencode($json_data);
				$input = str_replace("!!url_search_form!!", $url_search, $input);
				
				$input = str_replace("!!property_name!!", rawurlencode($property->pmb_name), $input);
				$input = str_replace("!!linked_tab_title!!", $property->label, $input);
				$input = str_replace("!!onto_new_order!!", $order, $input);
				
				$input .= $add_button;
				
				$input = str_replace("!!property_name!!", rawurlencode($property->pmb_name), $input);
	
				$row = str_replace("!!onto_row_inputs!!", $input, $row);
				$row = str_replace("!!onto_row_resource_selector!!", $ontology_tpl['form_row_content_resource_template'], $row);
				$row = str_replace("!!onto_row_order!!", $order, $row);
	
				$content .= $row;
// 				$first = false;
				$i++;
			}
		} else {
			$form=str_replace("!!onto_new_order!!","0" , $form);
				
			$row=$ontology_tpl['form_row_content_with_flex'];
				
			$inside_row=$ontology_tpl['form_row_content_resource_selector'];
			$inside_row .= $ontology_tpl['form_row_content_type'];
			
			$inside_row=str_replace("!!form_row_content_resource_selector_display_label!!","" , $inside_row);
			$inside_row=str_replace("!!form_row_content_resource_selector_value!!","" , $inside_row);
			$inside_row=str_replace("!!form_row_content_resource_selector_is_draft!!", "0", $inside_row);
			$inside_row=str_replace("!!onto_row_content_range!!",$range_for_form , $inside_row);
			$inside_row=str_replace("!!onto_current_element!!",onto_common_uri::get_id($item_uri),$inside_row);
			$inside_row=str_replace("!!onto_current_range!!",$range_for_form,$inside_row);
				
			$row=str_replace("!!onto_inside_row!!",$inside_row , $row);
				
			$input='';
			$input.=$ontology_tpl['form_row_content_input_remove'];
			$input.=$ontology_tpl['form_row_content_search'];
			
			if ($property->has_linked_form) {
				$access_granted = true;
				if (isset($dom_5) && !$dom_5->getRights($_SESSION['id_empr_session'],onto_common_uri::get_id($property->linked_form['scenario_uri']), 4)) {
					$access_granted = false;
				}
				if ($access_granted) {
					$input .= $ontology_tpl['form_row_content_linked_form'];
					
					$input .= $ontology_tpl['form_row_content_edit'];
					
					$url_create = './ajax.php?module=ajax&categ=contribution&sub='.$property->linked_form['form_type'].'&area_id='.$property->linked_form['area_id'].'&id=0&sub_form=1&form_id='.$property->linked_form['form_id'].'&form_uri='.urlencode($property->linked_form['form_id_store']);
					$input = str_replace("!!url_linked_form!!", $url_create, $input);				
					$input = str_replace("!!linked_tab_title!!", $property->label, $input);
					$input = str_replace("!!onto_new_order!!", "0", $input);
					$url_search = './ajax.php?module=ajax&categ=contribution&sub='.$property->linked_form['form_type'].'&area_id='.$property->linked_form['area_id'].'&id='.onto_common_uri::get_id($data->get_value()).'&sub_form=1&form_id='.$property->linked_form['form_id'].'&form_uri='.urlencode($property->linked_form['form_id_store']);
					$input = str_replace("!!url_search_linked_form!!", $url_search, $input);
					
					//plusieurs formulaires lis  un slecteur de ressource
					//$linked_forms_infos = "";
					//foreach($property->linked_form as $linked_form) {
						//if ($linked_forms_infos) {
							//$linked_forms_infos .= "<br/>";
						//}
						//$linked_forms_infos .= $ontology_tpl['form_row_content_linked_form_button'];
						//$url = './ajax.php?module=ajax&categ=contribution&sub='.$linked_form['form_type'].'&area_id='.$linked_form['area_id'].'&id=0&sub_form=1&form_id='.$linked_form['form_id'].'&form_uri='.urlencode($linked_form['form_uri']);
						//$linked_forms_infos = str_replace("!!url_linked_form!!", $url, $linked_forms_infos );
						//$linked_forms_infos = str_replace("!!linked_form_id!!", $linked_form['form_id'], $linked_forms_infos );
						//$linked_forms_infos = str_replace("!!linked_form_title!!", $linked_form['form_title'], $linked_forms_infos );	
						
					//}
					//$input = str_replace("!!linked_forms!!", $linked_forms_infos, $input);
					
	// 				$url = './ajax.php?module=ajax&categ=contribution&sub='.$property->linked_form[0]['form_type'].'&area_id='.$property->linked_form[0]['area_id'].'&id=0&sub_form=1&form_id='.$property->linked_form[0]['form_id'].'&form_uri='.urlencode($property->linked_form[0]['form_uri']);
	// 				$input = str_replace("!!url_linked_form!!", $url, $input);
	// 				$input = str_replace("!!linked_form_title!!", $property->linked_form[0]['form_title'], $input);
				}
			}
			$input .= $add_button;
			$input = str_replace("!!property_name!!", rawurlencode($property->pmb_name), $input);
			
			$row = str_replace("!!onto_row_inputs!!", $input, $row);
			$row = str_replace("!!onto_row_resource_selector!!", $ontology_tpl['form_row_content_resource_template'], $row);
			$row = str_replace("!!onto_row_order!!", "0", $row);
			
			$content .= $row;
		}	
	
		$input = '';	
		$form = str_replace("!!onto_rows!!", $content, $form);
		$form = str_replace("!!onto_row_scripts!!", static::get_scripts(), $form);
		$form = str_replace("!!onto_completion!!", self::get_completion_from_range($range_for_form), $form);	
		$form = str_replace("!!onto_equation_query!!", htmlentities(static::get_equation_query($property),ENT_QUOTES,$charset), $form);	
		$form = str_replace("!!onto_area_id!!", ($area_id ? $area_id : ''), $form);		
		$form = self::get_form_with_special_properties($property, $datas, $instance_name, $form);	
		$form = str_replace("!!onto_row_id!!", $instance_name.'_'.$property->pmb_name, $form);
	
		return $form;
	} // end of member function get_form
	
	/**
	 * 
	 * @param onto_common_property $property
	 * @return string
	 */
	protected static function get_equation_query($property) {	
		if(empty($property->pmb_extended['equation'])) {
			return '';
		}
		$query = "SELECT contribution_area_equation_query FROM contribution_area_equations WHERE contribution_area_equation_id='".$property->pmb_extended['equation']."'";
		
		
		$result = pmb_mysql_query($query);
		if(pmb_mysql_num_rows($result)){
			$row = pmb_mysql_fetch_object($result);
			return $row->contribution_area_equation_query;			
		}	
		return '';
	}
	
	public static function get_hidden_fields($property,$datas, $instance_name, $flag = false) {
		global $msg,$charset,$ontology_tpl; 
		global $origin, $origin_uri;
		
		$form=$ontology_tpl['form_row_hidden'];
		
		$content='';
		$value = "";
		if (!empty($origin) && $property->range[0] == $origin && !empty($origin_uri)) {
		   $value = $origin_uri; 
		}
		
		if(sizeof($datas)){	
			
			$new_element_order=max(array_keys($datas));
			
			$form=str_replace("!!onto_new_order!!",$new_element_order , $form);
						
			foreach($datas as $key=>$data){
				$row=$ontology_tpl['form_row_content_resource_selector_hidden'];
		
				if($data->get_order()){
					$order=$data->get_order();
				}else{
					$order=$key;
				}				
				$row=str_replace("!!onto_row_content_hidden_display_label!!",htmlentities($data->get_formated_value() ,ENT_QUOTES,$charset) ,$row);
				if ($key == 0 && $value) {
    				$row=str_replace("!!onto_row_content_hidden_value!!",htmlentities($value ,ENT_QUOTES,$charset) ,$row);
				} else {
				    $row=str_replace("!!onto_row_content_hidden_value!!",htmlentities($data->get_raw_value() ,ENT_QUOTES,$charset) ,$row);
				}
				$row=str_replace("!!onto_row_content_hidden_range!!",$property->range[0] , $row);
				$row=str_replace("!!onto_row_order!!",$order , $row);
		
				$content.=$row;
			}
		} else {	
				
			$form=str_replace("!!onto_new_order!!","0" , $form);
					
			$row = $ontology_tpl['form_row_content_resource_selector_hidden'];
			$row = str_replace("!!onto_row_content_hidden_display_label!!", "", $row);
			$row = str_replace("!!onto_row_content_hidden_value!!", htmlentities($value ,ENT_QUOTES,$charset), $row);
			$row = str_replace("!!onto_row_content_hidden_range!!",$property->range[0] , $row);
			$row=str_replace("!!onto_row_order!!","0" , $row);
				
			$content.=$row;
		}
		
		if ($flag) {
			$form=$content;
		} else {
			$form=str_replace("!!onto_rows!!",$content ,$form);
		}
				
		$form=str_replace("!!onto_row_id!!",$instance_name.'_'.$property->pmb_name , $form);
		
		return $form;
	}
	
	protected static function get_completion_from_range($range) {
	    //on rcupre le type de range en enlevant le prfixe propre  l'ontologie
	    switch ($range) {
	        case 'http://www.pmbservices.fr/ontology#linked_record' :
	        case 'http://www.pmbservices.fr/ontology#record' :
	            return 'notice';
	        case 'http://www.pmbservices.fr/ontology#author' :
	        case 'http://www.pmbservices.fr/ontology#responsability' :
	            return 'authors';
	        case 'http://www.pmbservices.fr/ontology#category' :
	            return 'categories';
	        case 'http://www.pmbservices.fr/ontology#publisher' :
	            return 'publishers';
	        case 'http://www.pmbservices.fr/ontology#collection' :
	            return 'collections';
	        case 'http://www.pmbservices.fr/ontology#sub_collection' :
	            return 'subcollections';
	        case 'http://www.pmbservices.fr/ontology#serie' :
	            return 'serie';
	        case 'http://www.pmbservices.fr/ontology#work' :
	            return 'titres_uniformes';
	        case 'http://www.pmbservices.fr/ontology#indexint' :
	            return 'indexint';
	        case 'http://www.w3.org/2004/02/skos/core#Concept' :
	            return 'concepts';
	        case 'http://www.pmbservices.fr/ontology#bulletin':
	            return 'bull';
	        default:
	            if(strpos($range,'http://www.pmbservices.fr/ontology#authperso') !== false){
	                return 'authperso_'.explode('_',$range)[1];
	            }
	            return'';
	    }
	}
	
	protected static function get_type_from_range($range) {
	    switch ($range) {
	        case 'http://www.pmbservices.fr/ontology#linked_record' :
	        case 'http://www.pmbservices.fr/ontology#record' :
	            return 'record';
	        case 'http://www.pmbservices.fr/ontology#author' :
	        case 'http://www.pmbservices.fr/ontology#responsability' :
	            return 'author';
	        case 'http://www.pmbservices.fr/ontology#category' :
	            return 'category';
	        case 'http://www.pmbservices.fr/ontology#publisher' :
	            return 'publisher';
	        case 'http://www.pmbservices.fr/ontology#collection' :
	            return 'collection';
	        case 'http://www.pmbservices.fr/ontology#sub_collection' :
	        case 'http://www.pmbservices.fr/ontology#subcollection' :
	            return 'subcollection';
	        case 'http://www.pmbservices.fr/ontology#serie' :
	            return 'serie';
	        case 'http://www.pmbservices.fr/ontology#work' :
	        case 'http://www.pmbservices.fr/ontology#linked_work' :
	            return 'work';
	        case 'http://www.pmbservices.fr/ontology#indexint' :
	            return 'indexint';
	        case 'http://www.w3.org/2004/02/skos/core#Concept' :
	            return 'concept';
	        case 'http://www.pmbservices.fr/ontology#bulletin':
	            return 'bull';
	        case 'http://www.pmbservices.fr/ontology#docnum' :
	            return 'docnum';
	        default:
	            if(strpos($range,'http://www.pmbservices.fr/ontology#authperso') !== false){
    	            return 'authperso_'.explode('_',$range)[1];
	            }
	            return '';
	    }
	    
	    return $completion;
	}
	
	public static function get_edit_url($entity, $scenario_id, $type, $params = array()) {
	    
        $uri = $entity['value'] ?? ($entity['uri'] ?? '');
        
	    $params['create'] = 1;
	    $params['scenario'] = $scenario_id ?? 0;
	    $params['area_id'] = $entity['area_id'] ?? ($entity['http://www.pmbservices.fr/ontology#area'] ?? 0);
	    $params['id'] = onto_common_uri::get_id($uri);
	    $params['form_id'] = $entity['form_id'] ?? ($entity['http://www.pmbservices.fr/ontology#form_id'] ?? 0);
	    $params['form_uri'] = $entity['form_uri'] ?? ($entity['http://www.pmbservices.fr/ontology#form_uri'] ?? 0);
	    $params['edit_contribution'] = 1;
	    $params['select_tab'] = 1;
	    $params['type'] = $type;
	    
	    $json_data = encoding_normalize::json_encode($params);
	    return "./select.php?what=contribution&selector_data=".urlencode($json_data);
	}
} // end of onto_common_datatype_resource_selector_ui
